/**
 * @file
 * Use Slim Select JS.
 */

(function ($, Drupal) {
  Drupal.behaviors.slimSelect = {
    attach(context) {
      // Switch to 'once' function from 'core/once', when support for
      // core/jquery.once is dropped.
      // @see https://www.drupal.org/project/slim_select/issues/3233011
      // @see https://www.drupal.org/node/3158256
      $(context).find('[data-drupal-slim-select]').once('slimSelect').each(function () {
        let attr = $(this).attr('data-drupal-slim-select');
        attr = JSON.parse(attr);

        const $selectElement = $(this);
        new SlimSelect({
          select: '#' + $selectElement.attr('id'),
          showSearch: attr['showSearch'],
          selectByGroup: attr['selectByGroup'],
        });
      });
    }
  };
})(jQuery, Drupal);
